<?php
/*
* Padmin Module
* @package: PerfCMS
*/

class IndexController extends Controller
{
	public function actionIndex()
	{
		$usr = new User();
		if(!$usr->loged() || $usr->level() < 2) 
		{
			header('location: /');
			exit;
		}
		$lang = new Lang();
		$this->getHeader(array('title' => $lang::get('padmin_title', 'padmin')));
		$this->render('index');
		$this->getFooter();
	}
	
	public function actionSettings()
	{
		$usr = new User();
		if(!$usr->loged() || $usr->level() < 2) 
		{
			header('location: /');
			exit;
		}
		$lang = new Lang();
		if(isset($_GET['act']) && $_GET['act'] == 'save')
		{
			$saveConf = PadminSettings::model()->findByPk('auto');
			$saveConf->pts = (empty($_POST['pts']) || $_POST['pts'] < 5 ? 10 : substr(Filters::num($_POST['pts']), 0, 2));
			$saveConf->open_site = substr(Filters::num($_POST['open_site']), 0, 1);
			$saveConf->open_reg = substr(Filters::num($_POST['site_signup']), 0, 1);
			$saveConf->access_site = substr(Filters::num($_POST['access_site']), 0, 1);
			$saveConf->language = substr(Filters::input($_POST['language']), 0, 7);
			// $saveConf->copyright = substr(Filters::input($_POST['copyright']), 0, 12);
			$saveConf->timezone = Filters::input($_POST['timezone']);
			$saveConf->keywords = Filters::input($_POST['keywords']);
			$saveConf->description = Filters::input($_POST['description']);
			$saveConf->save();
			//var_dump($saveConf);
			header('location: /padmin/index/settings?');
			exit();
		}
		$system = System::getSettings();
		$this->getHeader(array('title' => $lang::get('padmin_general_settings', 'padmin')));
		$langsDir = scandir(APP_ROOT.'/protected/messages');
		$this->render('settings', array('langs' => $langsDir, 'timezone' => $system['timezone']));
		$this->getFooter();
	}
	
	public function actionInfo()
	{
		$usr = new User();
		if(!$usr->loged() || $usr->level() < 2) 
		{
			header('location: /');
			exit;
		}
		$lang = new Lang();
		$this->getHeader(array('title' => $lang::get('padmin_system_info', 'padmin')));
		$this->render('info', array('YiiVersion' => Yii::getVersion(), 'PHPVersion' => PHP_VERSION));
		$this->getFooter();
	}
	
	public function actionDesign()
	{
		$usr = new User();
		if(!$usr->loged() || $usr->level() < 2) 
		{
			header('location: /');
			exit;
		}
		if(isset($_GET['act']) && $_GET['act'] == 'save')
		{
			$saveConf = PadminSettings::model()->findByPk('1');
			$saveConf->wap_theme = Filters::input($_POST['wap_theme']);
			$saveConf->web_theme = Filters::input($_POST['web_theme']);
			$saveConf->touch_theme = Filters::input($_POST['touch_theme']);
			$saveConf->active_switch = substr(Filters::num($_POST['active_switch']), 0, 1);
			$saveConf->default_type = substr(Filters::num($_POST['def_type']), 0, 1);
			$saveConf->save();
			header('location: /padmin/index/design?');
			exit();
		}
		$lang = new Lang();
		$wapDir = scandir(APP_ROOT .'/design/themes/wap');
		$webDir = scandir(APP_ROOT .'/design/themes/web');
		$touchDir = scandir(APP_ROOT .'/design/themes/touch');
		$this->getHeader(array('title' => $lang::get('padmin_design_settings', 'padmin')));
		$this->render('design', array('waps' => $wapDir, 'webs' => $webDir, 'touchs' => $touchDir));
		$this->getFooter();
	}
	
	public function actionStats()
	{
		$usr = new User();
		if(!$usr->loged() || $usr->level() < 2) 
		{
			header('location: /');
			exit;
		}
		$lang = new Lang;
		$db = PerfDb::init();
		$this->getHeader(array('title' => $lang::get('padmin_stats_info', 'padmin')));
		$users = $db->query("SELECT * FROM `users` WHERE `time` > '".(time()-60*60*24)."' LIMIT 5");
		$regs = $db->query("SELECT * FROM `users` LIMIT 5");
		$guests = $db->query("SELECT * FROM `guests` LIMIT 5");
		$all = $db->query("SELECT * FROM `users` WHERE `time` > '".(time()-60*60*24)."'")->rowCount();
		$this->render('stats', array('users' => $users, 'regs' => $regs, 'guests' => $guests, 'all' => $all));
		$this->getFooter();
	}
}
