<?php
/*
* User controller
* @package: PerfCMS
*/
class UserController extends Controller
{	
	
	public function actionIndex()
	{
		$user = new User;
		if(!$user->loged())
		{
			header('location: /');
			exit();
		}
		$lang = new Lang();
		$this->getHeader(array('title' => $lang::get('panel')), '/index::user_cabinet_location');
		$this->render('main');
		$this->getFooter();
	}
	
	public function actionSettings()
	{
		$user = new User;
		
		if(!$user->loged())
		{
			header('location: /');
			exit();
		}
		
		$lang = new Lang();
		$settings = User::$settings;
		$config = System::getSettings();
		
		if(isset($_GET['act']) && $_GET['act'] == 'save')
		{
			$uset = UserSettings::model()->findByPk(User::Id());
			// $uset->fast_mess = Filters::num($_POST['fast_mess']);
			$uset->timezone = Filters::input($_POST['timezone']);
			$uset->lang = (file_exists(APP_ROOT.'/protected/messages/'.Filters::input($_POST['language'])) ? Filters::input($_POST['language']) : $config['language']);
			@setcookie('lang', Filters::input($_POST['language']), time()+60*60*24*2500, '/');
			$uset->signature = (!empty($_POST['signature']) ? str_replace('http://', '', Filters::input($_POST['signature'])) : '');
			$uset->ames = substr(Filters::num($_POST['ames']), 0, 2);
			$uset->save();
			header('location: /user/settings?act=saved');
			exit;
		}
		$ldr = scandir(APP_ROOT.'/protected/messages');
		$this->getHeader(array('title' => $lang::get('general_settings')), '/index::user_cabinet_location');
		$this->render('generalSettings', array('timezone' => $settings['timezone'], 'lngs' => $ldr));
		$this->getFooter();
	}
	
	public function actionEditProfile()
	{
		$user = new User;
		if(!$user->loged())
		{
			header('location: /');
			exit();
		}
		$lang = new Lang();
		if(isset($_GET['act']) && $_GET['act'] == 'save')
		{
			$uset = EditProfile::model()->findByPk(User::Id());
			$uset->name = substr(Filters::input($_POST['name']), 0, 18);
			$uset->surname = substr(Filters::input($_POST['surname']), 0, 36);
			$uset->gender = substr(Filters::num($_POST['gender']), 0, 1);
			$day = substr(Filters::num($_POST['day']), 0, 2);
			$uset->day = (empty($day) || $day < 1 ? 1 : ($day > 31 ? 31 : $day));
			$month = substr(Filters::num($_POST['month']), 0, 2);
			$uset->month = (empty($month) || $month < 1 ? 1 : ($month > 12 ? 12 : $month));
			$year = substr(Filters::num($_POST['year']), 0, 4);
			$uset->year = (empty($year) || $year < 1960 ? 1960 : ($year > (date('Y')-6) ? date('Y')-6 : $year));
			$uset->icq = substr(Filters::num($_POST['icq']), 0, 9);
			$uset->phone = substr(Filters::input($_POST['phone']), 0, 18);
			$site = substr(Filters::input($_POST['site']), 0, 64);
			$uset->site = (preg_match('/http:\/\//i', $site) ? preg_replace('/http:\/\//i', '', $site) : $site);
			$uset->info = substr(Filters::input($_POST['info']), 0, 3500);
			$uset->save();
		header('location: /user/editProfile?act=saved');
		exit;
		}
		$this->getHeader(array('title' => $lang::get('edit_profile')));
		$this->render('editProfile', array('currentYear' => (date('Y')-6)));
		$this->getFooter();
	}
	
	public function actionList()
	{
		$lang = new Lang();
		$db = PerfDb::init();
		$this->getHeader(array('title' => $lang::get('users_list')), '/user/list::user_list_location');
		$listAm = $db->query("SELECT * FROM `users`")->rowCount();
		$pages = new Paginator($listAm, System::pages());
		global $start;
		$listArray = $db->query("SELECT * FROM `users` ORDER BY time DESC LIMIT $start, 15");
		$this->render('list', array('list' => $listArray, 'pages' => $pages));
		$this->getFooter();
	}
	
	public function actionOnline()
	{
		$lang = new Lang();
		$db = PerfDb::init();
		$this->getHeader(array('title' => $lang::get('users_online')), '/user/list::user_online_location');
		$listAm = $db->query("SELECT * FROM `users` WHERE `time` > '".(time()-300)."'")->rowCount();
		$pages = new Paginator($listAm, System::pages());
		global $start;
		$listArray = $db->query("SELECT * FROM `users` WHERE `time` > '".(time()-300)."' ORDER BY time DESC LIMIT $start, 15");
		$this->render('online', array('list' => $listArray, 'pages' => $pages));
		$this->getFooter();
	}
	
	public function actionPhoto()
	{
		$user = new User();
		if(!$user->loged())
		{
			header('location: /');
			exit();
		}
		$lang = new Lang();
		if(isset($_GET['act']) && $_GET['act'] == 'upload' && $_FILES['photo'])
		{
			if(file_exists(APP_ROOT.'/files/photos/'.User::Id().'.jpg'))
			{
				unlink(APP_ROOT.'/files/photos/'.User::Id().'.jpg');
				unlink(APP_ROOT.'/files/photos/'.User::Id().'_mini.jpg');
			}
			$file_info = pathinfo($_FILES['photo']['name']);
			$file_info['extension'] = strtolower($file_info['extension']);
			move_uploaded_file($_FILES['photo']['tmp_name'], APP_ROOT.'/cache/'.$file_info['filename'].'.'.$file_info['extension']);
			copy(APP_ROOT.'/cache/'.$file_info['filename'].'.'.$file_info['extension'], APP_ROOT.'/tmp/'.$file_info['filename'].'.'.$file_info['extension']);
			$photo = new Upload(APP_ROOT.'/cache/'.$file_info['filename'].'.'.$file_info['extension']);
			if($photo->uploaded)
			{
				$photo->allowed = array('image/*');
				$photo->file_new_name_body 	= User::Id().'_mini';
				$photo->image_convert 	= 'jpg';
				$photo->image_resize	= true;
				$photo->image_x		= 36;
				$photo->image_y		= 36;
				$photo->process(APP_ROOT. '/files/photos/');
				if ($photo->processed) 
				{
					// echo 'image resized';
					$photo->clean();
					// header('location: /user/photo/');
					// exit;
				} 
				else 
				{
					// echo 'error : ' . $photo->error;
					// header('location: /user/photo/');
					// exit;
				}
			}
			
			$photo = new Upload(APP_ROOT.'/tmp/'.$file_info['filename'].'.'.$file_info['extension']);
			if($photo->uploaded)
			{
				$photo->allowed = array('image/*');
				$photo->file_new_name_body 	= User::Id();
				$photo->image_convert 	= 'jpg';
				$photo->image_resize	= true;
				$photo->image_x		= 110;
				$photo->image_y		= 135;
				$photo->process(APP_ROOT. '/files/photos/');
				if ($photo->processed) 
				{
					// echo 'image resized';
					$photo->clean();
					header('location: /user/photo/');
					exit;
				} 
				else 
				{
					// echo 'error : ' . $photo->error;
					header('location: /user/photo/');
					exit;
				}
			}
		}
		elseif(isset($_GET['act']) && $_GET['act'] == 'delete')
		{
			if(file_exists(APP_ROOT.'/files/photos/'.User::Id().'.jpg'))
			{
				unlink(APP_ROOT.'/files/photos/'.User::Id().'.jpg');
				unlink(APP_ROOT.'/files/photos/'.User::Id().'_mini.jpg');
			}
			header('location: /user/photo');
			exit;
		}
		$this->getHeader(array('title' => $lang::get('edit_avatar')), '/index::user_cabinet_location');
		$this->render('photo');
		$this->getFooter();
	}
		
	public function actionLogin()
	{
		$usr = new User();
		if($usr->loged())
		{
			header('location: /');
			exit;
		}
		if(isset($_GET['login']) || isset($_POST['login']))
		{
		$nick = (isset($_GET['nickname']) ? Filters::input($_GET['nickname']) : Filters::input($_POST['nickname']));
		$pass = (isset($_GET['password']) ? Filters::crypt(Filters::input($_GET['password'])) : Filters::crypt(Filters::input($_POST['password'])));
		$auth = new User;
		$auth->login($nick, $pass);
		header('location: /');
		exit;
		}
		$lang = new Lang;
		$this->getHeader(array('title' => $lang::get('login')), '/user/login::user_login_location');
		$this->render('login');
		$this->getFooter();
	}
	
	public function actionCaptcha()
	{
		$captcha = new Captcha();
		return $captcha;
	}
	
	public function actionRegister()
	{
		$usr = new User();
		$db = PerfDb::init();
		$lang = new Lang;
		if($usr->loged())
		{
			header('location: /');
			exit;
		}
		$error = false;
		if(isset($_GET['finaly']))
		{
			$nick = filters::input($_POST['nickname']);
			$name = filters::input($_POST['name']);
			$password = filters::input($_POST['password']);
			$repassword = filters::input($_POST['repassword']);
			$email = filters::input($_POST['email']);
			$gender = filters::num($_POST['gender']);
			if(empty($nick) || mb_strlen($nick) < 3 || mb_strlen($nick) > 25 || !preg_match('/[a-zA-Z--0-9\_\-\@\.]/i', $nick))
			{
				$error .= $lang::get('register_nick_error');
			}
			elseif($db->query("SELECT * FROM `users` WHERE `nick` = '$nick'")->rowCount() != 0)
			{
				$error .= $lang::get('register_nick2_error');;
			}
			elseif(empty($name))
			{
				$error .= $lang::get('register_name_error');;
			}
			elseif(empty($password) || empty($repassword))
			{
				$error .= $lang::get('register_pass_error');;
			}
			elseif($password != $repassword)
			{
				$error .= $lang::get('register_pass2_error');;
			}
			elseif(empty($email) || !filter_var($email, FILTER_VALIDATE_EMAIL))
			{
				$error .= $lang::get('register_email_error');;
			}
			elseif($db->query("SELECT * FROM `users` WHERE `email` = '$email'")->rowCount() != 0)
			{
				$error .= $lang::get('register_email2_error');;
			}
			elseif($_POST['captcha'] != $_POST['captcha'])
			{
				$error .= $lang::get('captcha_error');
			}
			
			if($error == false)
			{
				$pass = filters::crypt($password);
				$conf = System::getSettings();
				$db->query("INSERT INTO `users` SET 
				`name` = '$name', 
				`nick` = '$nick', 
				`password` = '$pass', 
				`email` = '$email', 
				`gender` = '$gender', 
				`level` = '0',
				`active` = '0', 
				`time` = '".time()."', 
				`reg_time` = '".time()."', 
				`surname` = '', 
				`device` = '', 
				`phone` = '', 
				`icq` = '0', 
				`day` = '0', 
				`month` = '0',
				`year` = '0',
				`site` = '',
				`info` = '',
				`city` = '',
				`country` = '',
				`locate` = '',
				`ban_time` = '0',
				`ban_text` = '',
				`ip` = '".$_SERVER['REMOTE_ADDR']."'");
				$lastId = $db->lastInsertId();
				$locale = System::getLocale();
				$db->query("INSERT INTO `settings` SET
				`user_id` = '". $lastId ."',
				`lang` = '". $locale ."',
				`theme` = 'default',
				`web_theme` = 'default',
				`touch_theme` = 'default',
				`view_profile` = '0',
				`fast_mess` = '0',
				`show_email` = '0',
				`timezone` = '". $conf['timezone'] ."',
				`ames` = '10',
				`signature` = ''");
				// print_r($db->errorInfo());
				header('location: /user/login?nickname='.$nick.'&password='.$password.'&login');
				exit;
			}
		}
		$this->getHeader(array('title' => $lang::get('register')), '/user/register::user_register_location');
		$this->render('registration', array('err' => $error));
		$this->getFooter();
	}
	
	public function actionLogout()
	{
		$auth = new User;
		$auth->logout();
		$return = (isset($_GET['return']) ? Filters::input($_GET['return']) : '/');
		header('location: '.$return);
	}
	
	public function actionProfile()
	{
		$pid = Filters::num($_GET['profile']);
		$db = PerfDb::init();
		$lang = new Lang;
		if($pid == User::Id() || $pid == 0 || empty($pid) || $db->query("SELECT * FROM `users` WHERE `id` = '$pid'")->rowCount() == 0)
		{
		$profile = $db->query("SELECT * FROM `users` WHERE `id` = '".User::Id()."'")->fetch();
		}
		else
		{
		$profile = $db->query("SELECT * FROM `users` WHERE `id` = '$pid'")->fetch();
		}
		$this->getHeader(array('title' => $lang::get('profile_of').User::tnick($profile['id'])), '/user/profile-'.$pid.'::user_view_profile_location');
		$this->render('profile', array('profile' => $profile));
		$this->getFooter();
	}
	
	public function actionSecurity()
	{
		$usr = new User();
		if(!$usr->loged())
		{
			header('location: /');
			exit();
		}
		if(isset($_GET['act']) && $_GET['act'] == 'change_pass')
		{
			$user = new User;
			if(!empty($_POST['new_pass']) && !empty($_POST['ret_pass']) && !empty($_POST['cur_pass']))
			{
				$nPass = Filters::input($_POST['new_pass']);
				$rPass = Filters::input($_POST['ret_pass']);
				$cPass = Filters::crypt(Filters::input($_POST['cur_pass']));
				if($nPass != $rPass || mb_strlen($nPass) > 16 || mb_strlen($rPass) > 16)
				{
					$err = 'Passwords not true';
				}
				if($cPass != $user->data['password'])
				{
					$err .= 'Not true current Passwords';
				}
				if(!isset($err))
				{
					$usep = EditProfile::model()->findByPk(User::Id());
					$usep->password = Filters::crypt($rPass);
					$usep->save();
					header('location: /user/security');
					exit();
				}
			}
		}
		elseif(isset($_GET['act']) && $_GET['act'] == 'change_email')
		{
			$user = new User;
			if(!empty($_POST['new_email']) && !empty($_POST['cur_email']) && !empty($_POST['cur_pass']))
			{
				$nMail = Filters::input($_POST['new_email']);
				$cMail = Filters::input($_POST['cur_email']);
				$cPass = Filters::crypt(Filters::input($_POST['cur_pass']));
				if($cMail != $user->data['email'])
				{
					$err = 'Current e-mail not true';
				}
				if($cPass != $user->data['password'])
				{
					$err .= 'Not true current Password';
				}
				if(!isset($err))
				{
					$usep = EditProfile::model()->findByPk(User::Id());
					$usep->password = Filters::crypt($rPass);
					$usep->save();
					header('location: /user/security');
					exit();
				}
			}
		}
		$lang = new Lang();
		$this->getHeader(array('title' => $lang::get('security_settings')), '/index::user_cabinet_location');
		$this->render('security');
		$this->getFooter();
	}
	
	public function actionInterface()
	{
		$user = new User;
		if(!$user->loged())
		{
			header('location: /');
			exit();
		}
		$lang = new Lang;
		if(isset($_GET['act']) && $_GET['act'] == 'save')
		{
		$uset = UserSettings::model()->findByPk(User::Id());
		$theme = Filters::input($_POST['wap_theme']);
		$uset->theme = (file_exists(APP_ROOT.'/design/themes/wap/'.$theme) ? $theme : 'default');
		$web_theme = Filters::input($_POST['web_theme']);
		$uset->web_theme = (file_exists(APP_ROOT.'/design/themes/web/'.$web_theme) ? $web_theme : 'default');
		$touch_theme = Filters::input($_POST['touch_theme']);
		$uset->web_theme = (file_exists(APP_ROOT.'/design/themes/touch/'.$touch_theme) ? $touch_theme : 'default');
		$uset->save();
		header('location: /user/interface?act=saved');
		exit;
		}
		$wapDir = scandir(APP_ROOT .'/design/themes/wap');
		$webDir = scandir(APP_ROOT .'/design/themes/web');
		$touchDir = scandir(APP_ROOT .'/design/themes/touch');
		$this->getHeader(array('title' => $lang::get('design_settings')), '/index::user_cabinet_location');
		$this->render('interface', array('waps' => $wapDir, 'webs' => $webDir, 'touchs' => $touchDir));
		$this->getFooter();
	}

}
